program main
  implicit none
  integer, parameter :: m= !number of atoms
  real(8), parameter :: temp=  !K
  real(8), parameter :: tmax=  !evolution time
  real(8), parameter :: dt=  !time step
  integer :: shots=
  integer :: shots2=
  
  real(8), parameter :: hbar=1.054572d-34 
  real(8), parameter :: c = 299792458  
  real(8), parameter :: pi=3.141592653589793238d0
  real(8), parameter :: amu=1.66053873d-27
  real(8), parameter :: mass=87*amu 
  real(8), parameter :: g=9.81
  real(8), parameter :: kB=1.3806505d-23
  real(8), parameter :: a0=0.5291772108d-10

  real(8) :: t,Er,xc,yc,yc2,zc,vi,eta,A,vint,mint,start, finish
  real(8) :: gamma,vrec,wavevector,m_speed,theta,m_speedx,m_speedz
  real(8), dimension(m,6) :: lambda
  real(8), dimension(m,6) :: noise
  real(8), dimension(3) :: w=(/,,/)
  real(8), dimension(3) :: wf=(/,,/)
  real(8) :: win=2.d0*pi*200d0,xR=0.0034,wg=-73d-6*kB
  real(8), dimension(3) :: ww
  real(8), dimension(3) :: R
  integer :: kmax=tmax/dt
  integer, dimension(1) :: ss,sm
  integer :: k,i,j,iv,im, iz,ix,icount,iter,run,jj,mm,iterv,iterm
  character(3) :: file,filel
  integer, parameter :: res=4000,resv=1000
  real(8) :: xmin=, xmax=, vmax=,dx,dv,mx,sx,vx,vx2,vz,svx,svxx,svx2,svz,mz,sz,gamma_s
  real(8), dimension(res) :: d=0d0,d_z=0d0, x, dd
  real(8), dimension(resv):: vout=0d0,vout_z=0d0,d1,d2,v
  logical :: done=.false.
  call cpu_time(start)

  
  !/\/\/\/\/\/\/\/\/\
  vi=
  eta=
  A=
  dx=(xmax-xmin)/res
  dv=2*vmax/resv
  theta=
  !/\/\/\/\/\/\/\/\/\
  
  call srand(6)
  m_speed=sqrt(kB*temp/mass)
  R(:)=sqrt(kB*temp/mass/wf(:)**2)
  
  do i=1,m
   noise(i,1)=gauss(0)*R(1)
   lambda(i,1)=noise(i,1)
  end do 
  do i=1,m
   noise(i,2)=gauss(0)*R(2)
   lambda(i,2)=noise(i,2)
  end do 
  do i=1,m
   noise(i,3)=gauss(0)*R(3)
   lambda(i,3)=noise(i,3)
  end do 
  do iv=1,m
   noise(iv,4)=gauss(0)*m_speed
   lambda(iv,4)=noise(iv,4)
  end do 
  do iv=1,m
   noise(iv,5)=gauss(0)*m_speed
   lambda(iv,5)=noise(iv,5)
  end do 
  do iv=1,m
   noise(iv,6)=gauss(0)*m_speed
   lambda(iv,6)=noise(iv,6)
  end do 
  
  icount=0
  open(UNIT=30,FILE="trajectory.dat",STATUS='unknown')
  open(UNIT=31,FILE="mx.dat",STATUS='unknown')
  open(UNIT=39,FILE="densityx.dat",STATUS='unknown')
  open(UNIT=40,FILE="tofx.dat",STATUS='unknown')
  open(UNIT=41,FILE="densityz.dat",STATUS='unknown')
  open(UNIT=42,FILE="tofz.dat",STATUS='unknown')
  do run=1,kmax
     t=run*dt
    
     do j=1,res
      do jj=1,m
        if ((lambda(jj,1) .ge. xmin+(j-1)*dx) .and. (lambda(jj,1) .le. xmin+(j)*dx)) then
         d(j)=d(j)+1
         x(j)=xmin+(j)*dx
        end if
        if ((lambda(jj,3) .ge. xmin+(j-1)*dx) .and. (lambda(jj,3) .le. xmin+(j)*dx)) then
         d_z(j)=d_z(j)+1
        end if
      end do
     end do

     do j=1,resv
      do jj=1,m   
        if ((lambda(jj,4) .ge. -vmax+(j-1)*dv) .and. (lambda(jj,4) .le. -vmax+j*dv)) then
         vout(j)=vout(j)+1
         v(j)=-vmax+j*dv
        end if
        if ((lambda(jj,6) .ge. -vmax+(j-1)*dv) .and. (lambda(jj,6) .le. -vmax+j*dv)) then
         vout_z(j)=vout_z(j)+1
        end if
      end do 
     end do
     
     mx=sum(d(:)*x(:)/m)
     mz=sum(d_z(:)*x(:)/m)
     sx=sqrt(sum(d(:)/m*(x(:)-mx)**2))
     sz=sqrt(sum(d_z(:)/m*(x(:)-mz)**2))
     vx=sum(vout(:)*v(:)/m)
     svxx=sqrt(sum(vout(:)/m*(v(:)-vx)**2))    
     vx2=sum(vout(:)*v(:)/m,mask=v .le. 0d0)
     svx2=sqrt(sum(vout(:)/m*(v(:)-vx2)**2, mask=v .le. 0d0))
     vz=sum(vout_z(:)*v(:)/m)
     svz=sqrt(sum(vout_z(:)/m*(v(:)-vz)**2)) 
     where ((x .gt. +vi*run*dt) .and. (x .lt. ))
      dd=d
     elsewhere
      dd=0d0
     end where  
     svx=min(svxx,0.5*sqrt(2*eta*A/mass))
     gamma_s=maxval(dd(:))/2/dx/sz**2*4*pi*( )**2*(svx+2*svz)/3
     
     if (gamma_s*dt .gt. ) then
      m_speed=( *svx+ *svz)
      write(*,*) '----><----',svx,gamma_s, maxval(dd(:))/2/dx/sz**2
      do iv=1,m
       if ((lambda(iv,1) .gt. +vi*run*dt) .and. (lambda(iv,1) .lt. )) then
       noise(iv,4)=gauss(0)*m_speed
       lambda(iv,4)=noise(iv,4)
       end if
      end do 
      do iv=1,m
       if ((lambda(iv,1) .gt. +vi*run*dt) .and. (lambda(iv,1) .lt. )) then 
       noise(iv,6)=gauss(0)*m_speed
       lambda(iv,6)=noise(iv,6)
       end if
      end do
     end if  
          
     if(mod(run,(kmax/shots)).eq. 0.) then
        icount = icount+1
       	WRITE(file,'(i3.3)') icount
       	write(*,*) icount
       	write(*,*) 't=',t
       	write(*,*) gamma_s, maxval(dd(:))/dx/sz**2
       	call wrt_dat(file)
       	call cpu_time(finish)
        write(*,*) 'tempo=',finish-start
     end if
         
     if(mod(run,(kmax/shots2)).eq. 0.) then   
     vint=maxval(vout)
     ss=maxloc(vout(:))
     mint=maxval(d)
     sm=maxloc(d(:))
     iterv=0
     iterm=0
     do while(.not. done) 
      iterv=iterv+1
      vint=vint+vout(minval(ss)+iterv)+vout(minval(ss)-iterv)    
      if (vint/m .ge. 0.682) then
      done= .true.
      end if
     end do
     done=.false.   
     do while(.not. done) 
      iterm=iterm+1
      mint=mint+d(minval(sm)+iterm)+d(minval(sm)-iterm)    
      if (mint/m .ge. 0.682) then
      done= .true.
      end if
     end do
     done=.false. 
     write(30,*) t, lambda(:,1)
     if (t .le. ) then
      write(31,*) t, mx, sx,vx,svx,iterv*dv,mm,iterm*dx,svx
     else
      write(31,*) t, mx, sx,vx,svx,iterv*dv,mm,iterm*dx,svx2
     end if
     write(39,*) d(:)
     write(40,*) vout(:)
     write(41,*) d_z(:)
     write(42,*) vout_z(:)
     iterv=0    
     iterm=0
     end if
     call scaling(lambda)    
     d1=vout
     d2=vout_z    
     d=0d0
     vout=0d0
     d_z=0d0
     vout_z=0d0 
     ss=0
     sm=0
         
  end do
  close(30)
  close(31)
  close(39)
  close(40)
  close(41)
  close(42)
  call cpu_time(finish)
  write(*,*) finish-start

contains
  subroutine scaling(v)
    implicit none
    real(8), dimension(m,6) :: v,dv

    call derivs(v,dv)
    call rk4(v,dv,v)
    
  end subroutine scaling

  subroutine rk4(y,dydx,yout)
    implicit none
    real(8), dimension(m,6) :: dydx,y,yout
    real(8), dimension(m,6) :: dym,dyt,yt
    real(8) :: h6,hh
    real(8) :: h

    h=dt
    hh=h*0.5
    h6=h/6.
    yt(:,:)=y(:,:)+hh*dydx(:,:)
    call derivs(yt,dyt)
    yt(:,:)=y(:,:)+hh*dyt(:,:)
    call derivs(yt,dym)
    yt(:,:)=y(:,:)+h*dym(:,:)
    dym(:,:)=dyt(:,:)+dym(:,:)
    call derivs(yt,dyt)
    yout(:,:)=y(:,:)+h6*(dydx(:,:)+dyt(:,:)+2.*dym(:,:))

  end subroutine rk4

  subroutine derivs(u,du)
    implicit none
    real(8), dimension(m,6) :: u,du 
    real(8) :: sigma= , sigma2=, omega
    real(8), dimension(m) :: V,Vz,vx,xc0,zc0,xc1,zc1,pot
      
    xc0(:)=
    zc0(:)=
    
    xc1(:)=
    zc1(:)=
    
    ww=wf

    do i=1,m
    if (abs(u(i,1)) .ge. ) then
       pot(i)=wg*(u(i,1))/xR**2/(1+(u(i,1))**2/xR**2)**(3./2.)  
    else   
       pot(i)=ww(1)**2*u(i,1)
    end if  
     
    V(i)= -A/sigma2**2*(u(i,1)-xc0(i))*exp(-(u(i,1)-xc0(i))**2/sigma2**2/2)/mass &
        & -A*eta/sigma**2*(u(i,1)-xc1(i))*exp(-(u(i,1)-xc1(i))**2/sigma**2/2)/mass  &
        & +pot(i)
    Vz(i)= -A/sigma2**2*(u(i,3)-zc0(i))*exp(-(u(i,3)-zc0(i))**2/sigma2**2/2)/mass &
        & -A*eta/sigma**2*(u(i,3)-zc1(i))*exp(-(u(i,3)-zc1(i))**2/sigma**2/2)/mass  &
        & +ww(3)**2*u(i,3)               
    end do

    
    du(:,1)=u(:,4)			
    du(:,2)=u(:,5)    			
    du(:,3)=u(:,6)     			
    du(:,4)=-V(:)
    du(:,5)=-ww(2)**2*u(:,2)  	
    du(:,6)=-Vz(:)
    
    end subroutine derivs
    
    subroutine wrt_dat(number)
    implicit none
    real(8), dimension(resv,resv) :: dtot
    character(3) :: number

    write(*,*) 'write file'

    open(UNIT=29,FILE="dtot-"//number//".dat",STATUS='unknown')
    
     do j=1,resv
         dtot(:,j)=d1(:)*d2(j)
     end do
    
    do k=1,resv 
          write(29,*) dtot(:,k)
    end do
          
    close(29)

  end subroutine wrt_dat
    
   function gauss(j) result(gasdev)
   implicit none
   real(8) ::fac,gset,v1,v2,rsq,input,gasdev
   integer :: iset=0,j
      !gaussian distribution
      if (iset .eq. 0) then
1        v1=2.d0*rand(0)-1.d0
         v2=2.d0*rand(0)-1.d0
         rsq=v1**2+v2**2
         if(rsq .ge. 1. .or. rsq .eq. 0.d0) goto 1
         fac=sqrt(-2.d0*log(rsq)/rsq)
         gset=v1*fac
         gasdev=v2*fac
         iset=1
      else
         gasdev=gset
         iset=0
      end if
   end function gauss   
    
end program main